
-- ------------------------ CONFIG ------------------------ 
radius_range = 3000  -- Search Range I think is in meters couldn't check this properly
jtacname = "JTAC"
check_time = 20 -- in seconds, how often should check for enemies
jtaccallsign = 3 -- see below list
jtacfreq = 030000000  -- has to be 9 digits THIS IS 244.00 AM if 244000000
jtacmodulation = 1 -- 0 am 1 fm

flagTargetdetected = 999 -- <-- Flag number

-- ----------------------------------------------------------
--[[
1  Axeman 
2  Darknight
3  Warrior
4  Pointer  
5  Eyeball  
6  Moonbeam 
7  Whiplash 
8  Finger 
9  Pinpoint 
10 Ferret 
11 Shaba  
12 Playboy  
13 Hammer 
14 Jaguar 
15 Deathstar  
16 Anvil  
17 Firefly  
18 Mantis 
19 Badger
]]--

local enemyvisible = false
local _jtacGroup = Group.getByName(jtacname)
local moving = true
local engagedTargets = {}

local selectedtarget 
local _jtacunit = _jtacGroup:getUnit(1) -- only first unit in group

local _stoproute = { 
                    id = 'StopRoute', 
                    params = { 
                      value = true, 
                      } ,
                   }
local _resumeroute = { 
                      id = 'StopRoute', 
                       params = { 
                          value = false, 
                         } ,
                      }

function setcontroller(_bool)
  if _jtacGroup ~= nil then
 
    local _route
    
    if _bool then
   
      _route =  _stoproute
    else
      _route = _resumeroute
    end 
    local _controller = _jtacGroup:getController();
          _controller:setCommand(_route)
          
          
  end
end   

function engageGroup( _group )
  local _groupid = _group:getID()
  
  local FAC_AttackGroup = { 
  id = 'FAC_AttackGroup', 
  params = { 
    groupId = _groupid,
  --  weaponType = number,
    designation = AI.Task.Designation.AUTO,
    datalink = true,
    frequency = jtacfreq,
    modulation = jtacmodulation,
    callname = jtaccallsign,
    number = 1 ,
    priority = 1 ,  
  } 
}

local _controller = _jtacunit:getController();

_controller:pushTask(FAC_AttackGroup)


end


function checkforenemies( _Unit )
  
    local _unitPoint = _Unit:getPoint()
    local _coa       = _Unit:getCoalition()
    local _offsetPos = { x = _unitPoint.x, y = _unitPoint.y + 2.0, z = _unitPoint.z }
    enemyvisible = false
    local _volume = {
        id = world.VolumeType.SPHERE,
        params = {
            point = _offsetPos,
            radius = radius_range
        }
    }
    local visibletargets = {}
  --  trigger.action.outTextForCoalition(2, "Checking", 10)
    local _searchenemies = function(_unit, _coa)
        pcall(function()
            if _unit ~= nil
                    and _unit:getLife() > 1
                    and _unit:isActive()
                    and _unit:getCoalition() ~= _coa
                    and not _unit:inAir() then
    
                local _tempPoint = _unit:getPoint()
                local unitname = _unit:getName()            
                local unittypename = _unit:getTypeName()
                
              local _offsetEnemyPos = { x = _tempPoint.x, y  = _tempPoint.y +2, z = _tempPoint.z }
                
                
                if land.isVisible(_offsetPos,_offsetEnemyPos ) then
                  enemyvisible = true           
                
                  if visibletargets[unitname] == nil then
                      visibletargets[unitname] = _unit
                  end
                else
                  if visibletargets[unitname] ~= nil then
                      visibletargets[unitname] = nil
                  end
                  
                end
                
            end
        end)
        return true
    end
    
    world.searchObjects(Object.Category.UNIT, _volume, _searchenemies, _coa)
   
  --  trigger.action.outTextForCoalition(2, "Checking", 10)
    if enemyvisible then
       --trigger.action.outTextForCoalition(2, "Visible", 10)
         if moving == true then
            moving = false
            
            --trigger.action.outTextForCoalition(2, "JTAC Stopped", 10)
            
         end
         trigger.action.setUserFlag(flagTargetdetected, true )
         setcontroller(true) -- Stop JTAC
        
         for key, _detectedunit2 in pairs (visibletargets)    do
              
                
                if engagedTargets[key] == nil then  --add task
                 
                   local _group = _detectedunit2:getGroup()
                   engageGroup( _group )
                   engagedTargets[key] = _detectedunit2
                   --trigger.action.outTextForCoalition(2, "New Target", 10)
                end
         end
         
         for key, value in pairs (engagedTargets) do
            
            if visibletargets[key] == nil then
                visibletargets[key] = nil
            end
          
         
         end
    else
         if moving == false then      
          moving = true
             --trigger.action.outTextForCoalition(2, "JTAC Moving", 10)
            setcontroller(false)
         end
          trigger.action.setUserFlag(flagTargetdetected, false )
    
    end
    
     timer.scheduleFunction(checkforenemies, _Unit, timer.getTime() + check_time)
    
end



--trigger.action.outTextForCoalition(2, "JTAC Script Running", 10)

timer.scheduleFunction(checkforenemies, _jtacunit, timer.getTime() + check_time)

   
